# -*- coding: UTF-8 -*-
##########################################################################
# TcosMonitor writen by MarioDebian <mariodebian@gmail.com>
#
#    TcosMonitor version 0.2.32-lliurex38
#
# Copyright (c) 2006 Mario Izquierdo <mariodebian@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
###########################################################################
""" template extension """

from gettext import gettext as _
import sys, os

from tcosmonitor import shared
from tcosmonitor.TcosExtensions import TcosExtension


def print_debug(txt):
    if shared.debug:
        print >> sys.stderr, "%s::%s" % (__name__, txt)
        #print("%s::%s" % (__name__, txt), file=sys.stderr)


class LogOut(TcosExtension):
    def register(self):
        if os.path.isfile(shared.IMG_DIR + "menu_restartx_custom.png"):
            img_rx="menu_restartx_custom.png"
        else:
            img_rx="menu_restartx.png"
        self.main.menus.register_simple( _("Logout client"),  img_rx, 0, self.logout, "restartx")
        self.main.menus.register_all( _("Logout clients"), img_rx , 0, self.logout_all, "restartx")
        

    def logout(self, w, ip):
        if not self.get_client():
            return
        if len(self.connected_users) == 0 or self.connected_users[0] == shared.NO_LOGIN_MSG:
            shared.error_msg ( _("User not logged") )
            return

        msg=_( _("Do you want to logout user: %s?" ) %(self.connected_users_txt) )
        if shared.ask_msg ( msg ):
            self.main.worker=shared.Workers(self.main, None, None)
            self.main.worker=shared.Workers(self.main, target=self.logout_th, args=(None,) )
            self.main.worker.start()
            
    def logout_th(self, *args):
        print_debug("logout_th() users=%s len=%s" %(self.newallclients, len(self.newallclients)))
        newusernames=[]
        timeout=self.main.config.GetVar("actions_timeout")
        msg=_("Session will close in %s seconds") %timeout
        remote_cmd="/usr/lib/tcos/session-cmd-send LOGOUT %s %s" %(timeout, msg.replace("'", "´"))
            
        if self.connected_users[0].find(":") != -1:
            # we have a standalone user...
            self.main.xmlrpc.DBus("exec", remote_cmd )
        else:
            newusernames.append(self.connected_users[0])
                    
        self.main.dbus_action.do_exec(newusernames, remote_cmd )
        self.main.common.threads_enter("TcosActions::action_for_clients doing action")
        self.main.write_into_statusbar( _("Client disconnected in %s seconds." %timeout))
        self.main.common.threads_leave("TcosActions::action_for_clients doing action")

    def logout_all(self, widget):
        if not self.get_all_clients():
            return

        if len(self.connected_users) == 0 or self.connected_users[0] == shared.NO_LOGIN_MSG:
            shared.error_msg ( _("User not logged") )
            return
        
        users_txt=self.connected_users_txt
        if (len(users_txt) > 133): users_txt="%s..." %users_txt[0:130]
        msg=_( _("Do you want to logout the following users:\n%s?" )%(users_txt) )
        if shared.ask_msg ( msg ):
            self.main.worker=shared.Workers(self.main, None, None)
            self.main.worker=shared.Workers(self.main, target=self.logout_all_th, args=(None,) )
            self.main.worker.start()
            
    def logout_all_th(self, *args):
        print_debug("logout_all_th() users=%s len=%s" %(self.newallclients, len(self.newallclients)))
        newusernames=[]
        timeout=self.main.config.GetVar("actions_timeout")
        msg=_("Session will close in %s seconds") %timeout
        remote_cmd="/usr/lib/tcos/session-cmd-send LOGOUT %s %s" %(timeout, msg.replace("'", "´"))
         
        for user in self.connected_users:
            if user.find(":") != -1:
                # we have a standalone user...
                usern, ip = user.split(":")
                self.main.xmlrpc.newhost(ip)
                self.main.xmlrpc.DBus("exec", remote_cmd )
            else:
                newusernames.append(user)
                        
        self.main.dbus_action.do_exec( newusernames, remote_cmd )
        self.main.common.threads_enter("TcosActions::action_for_clients doing action")
        self.main.write_into_statusbar( _("Clients disconnected in %s seconds." %timeout))
        self.main.common.threads_leave("TcosActions::action_for_clients doing action")

__extclass__=LogOut






